package mx.transport.recharge.controller;


import io.reactivex.Observable;
import io.reactivex.android.schedulers.AndroidSchedulers;
import io.reactivex.schedulers.Schedulers;
import mx.transport.recharge.model.CardBuy;
import mx.transport.recharge.model.Configuration;
import mx.transport.recharge.model.response.BaseResponse;
import mx.transport.recharge.model.Login;
import mx.transport.recharge.model.transaction.BuyTransaction;
import mx.transport.recharge.model.transaction.RechargeTransaction;
import mx.transport.recharge.service.ApiService;

public class MainController {

    private ApiService apiService;

    public MainController(ApiService apiService) {
        this.apiService = apiService;
    }

    public Observable<BaseResponse> callLogin(Login login) {
        return apiService.requestLogin(login).subscribeOn(Schedulers.newThread()).observeOn(AndroidSchedulers.mainThread());
    }

    public Observable<BaseResponse> callConfiguration(Configuration configuration){
        return apiService.requestConfiguration(configuration).subscribeOn(Schedulers.newThread()).observeOn(AndroidSchedulers.mainThread());
    }

    public Observable<BaseResponse> callBuyCard(CardBuy cardBuy) {//BuyTransaction transaction
        return apiService.requestBuyCard(cardBuy).subscribeOn(Schedulers.newThread()).observeOn(AndroidSchedulers.mainThread());
    }

    public Observable<BaseResponse> callRecharge(RechargeTransaction transaction) {
        return apiService.requestRecharge(transaction).subscribeOn(Schedulers.newThread()).observeOn(AndroidSchedulers.mainThread());
    }

}
