package mx.transport.recharge.custom;

import android.app.DatePickerDialog;
import android.app.Dialog;
import android.app.DialogFragment;
import android.os.Bundle;

import java.util.Calendar;

public class DataPickerFragment extends DialogFragment {

    private DatePickerDialog.OnDateSetListener listener;
    private boolean startDateIsNow = false;

    public static DataPickerFragment newInstance(DatePickerDialog.OnDateSetListener listener){
        DataPickerFragment fragment = new DataPickerFragment();
        fragment.setListener(listener);
        return fragment;
    }

    public static DataPickerFragment newInstance(boolean startDateIsNow, DatePickerDialog.OnDateSetListener listener){
        DataPickerFragment fragment = new DataPickerFragment();
        fragment.setListener(listener);
        fragment.setStartDateIsNow(startDateIsNow);
        return fragment;
    }
    
    @Override
    public Dialog onCreateDialog(Bundle savedInstanceState) {
        final Calendar c = Calendar.getInstance();
        int year = c.get(Calendar.YEAR);
        int month = c.get(Calendar.MONTH);
        int day = c.get(Calendar.DAY_OF_MONTH);

        DatePickerDialog dialog = new DatePickerDialog(getActivity(), listener, year, month, day);

        if(startDateIsNow){
            dialog.getDatePicker().setMinDate(c.getTimeInMillis());
            c.add(Calendar.MONTH, 3);
            dialog.getDatePicker().setMaxDate(c.getTimeInMillis());
        }else {
            c.add(Calendar.YEAR, -16);
            dialog.getDatePicker().setMaxDate(c.getTimeInMillis());
        }
        return dialog;
    }

    public void setListener(DatePickerDialog.OnDateSetListener listener){
        this.listener = listener;
    }

    public void setStartDateIsNow(boolean startDateIsNow) {
        this.startDateIsNow = startDateIsNow;
    }

}
