package mx.transport.recharge.di.component;

import javax.inject.Singleton;

import dagger.Component;
import mx.transport.recharge.RechargeApplication;
import mx.transport.recharge.di.module.ControllerModule;
import mx.transport.recharge.di.module.DatabaseModule;
import mx.transport.recharge.di.module.NavigatorModule;
import mx.transport.recharge.di.module.PreferenceModule;

@Singleton
@Component(modules = {PreferenceModule.class, NavigatorModule.class, ControllerModule.class, DatabaseModule.class})
public interface MainComponent extends GraphComponent {

    final class Initializer {
        public static MainComponent init(RechargeApplication application) {
            return DaggerMainComponent
                    .builder()
                    .navigatorModule(new NavigatorModule())
                    .controllerModule(new ControllerModule())
                    .preferenceModule(new PreferenceModule(application))
                    .databaseModule(new DatabaseModule())
                    .build();

        }
    }

}