package mx.transport.recharge.model.response;

import android.util.Log;

import com.google.gson.JsonDeserializationContext;
import com.google.gson.JsonDeserializer;
import com.google.gson.JsonElement;
import com.google.gson.JsonObject;
import com.google.gson.JsonParseException;

import java.lang.reflect.Type;

import mx.transport.recharge.util.constants.RechargeConstants;

public class BaseResponseDeserialize implements JsonDeserializer<BaseResponse> {

    @Override
    public BaseResponse deserialize(JsonElement json, Type typeOfT, JsonDeserializationContext context) throws JsonParseException {
        BaseResponse baseResponse = new BaseResponse();
        try {
            JsonObject jsonObject = json.getAsJsonObject();
            if (jsonObject.has(RechargeConstants.STATUS)) {
                baseResponse.setStatus(jsonObject.get(RechargeConstants.STATUS).getAsBoolean());
            }
            if (jsonObject.has(RechargeConstants.MESSAGE)) {
                baseResponse.setMessage(jsonObject.get(RechargeConstants.MESSAGE).getAsString());
            }
            if (jsonObject.has(RechargeConstants.RESPONSE)) {
                baseResponse.setResponse(jsonObject.get(RechargeConstants.RESPONSE).toString());
            }
        } catch (Exception e) {
            e.printStackTrace();
            Log.e("TAG", e.getMessage());
        }
        return baseResponse;
    }
}
