package mx.transport.recharge.ui.home;

import android.os.Bundle;


import android.support.annotation.NonNull;
import android.support.annotation.Nullable;
import android.view.LayoutInflater;
import android.view.View;
import android.view.ViewGroup;

import butterknife.ButterKnife;
import butterknife.OnClick;
import mx.transport.recharge.R;
import mx.transport.recharge.activities.MainActivity;
import mx.transport.recharge.base.FragmentBase;
import mx.transport.recharge.di.manager.NavigatorManager;


public class HomeFragment extends FragmentBase implements HomeView {

    private static final String TAG = HomeFragment.class.getName();
    private HomePresenter presenter;

    public static HomeFragment newInstance() {
        return new HomeFragment();
    }

    @Override
    public View onCreateView(LayoutInflater inflater, ViewGroup container, Bundle savedInstanceState) {
        rootView = inflater.inflate(R.layout.fragment_home, container, false);
        unbinder = ButterKnife.bind(this, rootView);
        presenter = new HomePresenter(this, mainController, preferences, realmConfiguration, this);
        return rootView;
    }

    @Override
    public void onViewCreated(@NonNull View view, @Nullable Bundle savedInstanceState) {
        super.onViewCreated(view, savedInstanceState);
        presenter.configurationService();
    }

    @OnClick({R.id.cv_buy, R.id.cv_recharge, R.id.cv_consulting})
    public synchronized void onActions(View view){
        switch (view.getId()){
            case R.id.cv_buy:
                navigationManager.navigation(NavigatorManager.F_BUY, getString(R.string.lbl_menu_buy), null);
                break;
            case R.id.cv_recharge:
                navigationManager.navigation(NavigatorManager.F_RECHARGER, getString(R.string.lbl_menu_recharge), null);
                break;
            case R.id.cv_consulting:
                navigationManager.navigation(NavigatorManager.F_CONSULTING, getString(R.string.lbl_menu_consult), null);
                break;
        }
    }

    @Override
    public void onResume() {
        super.onResume();
        ((MainActivity)activity).onDisableForegroundDispatch();
    }

    @Override
    public void onDestroy() {
        super.onDestroy();
        if (unbinder != null) {
            unbinder.unbind();
        }
    }

}
