package mx.transport.recharge.base;


import android.os.Bundle;
import androidx.annotation.Nullable;
import androidx.fragment.app.Fragment;
import android.view.View;


import javax.inject.Inject;
import javax.inject.Named;

import butterknife.Unbinder;
import mx.transport.recharge.controller.MainController;
import mx.transport.recharge.custom.MProgressDialog;
import mx.transport.recharge.di.manager.DaggerManager;
import mx.transport.recharge.di.manager.NavigatorManager;
import mx.transport.recharge.preference.RechargePreference;
import mx.transport.recharge.realm.RealmConfiguration;
import mx.transport.recharge.util.RechargeUtil;

public class FragmentBase extends Fragment {

    private static final String TAG = FragmentBase.class.getName();
    public static ActivityBase activity;
    public Unbinder unbinder;
    public RechargeUtil util;
    public View rootView;
    private MProgressDialog progressDialog = null;

    @Inject
    public NavigatorManager navigationManager;

    @Inject
    public RechargePreference preferences;

    @Inject
    @Named("main")
    public MainController mainController;

    @Inject
    public RealmConfiguration realmConfiguration;


    @Override
    public void onStart() {
        super.onStart();
    }

    @Override
    public void onCreate(@Nullable Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);
        DaggerManager.component().inject(this);
        this.activity = (ActivityBase) getActivity();
        this.util = RechargeUtil.getInstance(activity);
    }

    public void onBackNavigation() {
        activity.onBackPressed();
    }


    @Override
    public void onDestroy() {
        super.onDestroy();
        if (progressDialog != null && progressDialog.isShowing()) {
            progressDialog.cancel();
            progressDialog = null;
        }
    }

}
