package mx.transport.recharge.di.manager;

import mx.transport.recharge.RechargeApplication;
import mx.transport.recharge.di.component.GraphComponent;
import mx.transport.recharge.di.component.MainComponent;

public class DaggerManager {

    private static DaggerManager _instance = null;
    private GraphComponent graph;

    private DaggerManager(){}

    public synchronized static DaggerManager getInstance(){
        if(_instance == null){
            _instance = new DaggerManager();
        }
        return _instance;
    }

    public static GraphComponent component(){
        return getInstance().graph;
    }

    public void buildComponentAndInject(RechargeApplication application){
        graph = MainComponent.Initializer.init(application);
        graph.inject(application);
    }

}
