package mx.transport.recharge.model.response;

import com.google.gson.annotations.SerializedName;

import java.io.Serializable;
import java.util.ArrayList;
import java.util.Arrays;
import java.util.List;

import mx.transport.recharge.model.Blacklist;
import mx.transport.recharge.model.CardTypes;
import mx.transport.recharge.model.Companies;
import mx.transport.recharge.model.CostLimit;
import mx.transport.recharge.model.Movements;
import mx.transport.recharge.model.PointOfSale;
import mx.transport.recharge.model.RechargeLimit;

public class ConfigurationResponse implements Serializable {

    @SerializedName("TipoTarjeta")
    private CardTypes[] cardTypes;
    @SerializedName("TopeRecarga")
    private RechargeLimit[] rechargelimits;
    @SerializedName("TopeCostos")
    private CostLimit[] costLimits;
    @SerializedName("PuntoVenta")
    private PointOfSale [] pointOfSales;
    @SerializedName("RelacionCompania")
    private Companies [] companies;
    @SerializedName("ListaNegra")
    private Blacklist [] blacklists;
    @SerializedName("CatalogoMovimientos")
    private Movements [] movements;

    private List<CardTypes> cardTypesList = new ArrayList<>();
    private List<RechargeLimit> rechargeLimitList = new ArrayList<>();
    private List<CostLimit> costLimitList = new ArrayList<>();
    private List<PointOfSale> pointOfSaleList = new ArrayList<>();
    private List<Companies> companiesList = new ArrayList<>();
    private List<Blacklist> blacklistList = new ArrayList<>();
    private List<Movements> movementsList = new ArrayList<>();

    private CardTypes[] getCardTypes() {
        return cardTypes;
    }

    private void setCardTypes(CardTypes[] cardTypes) {
        this.cardTypes = cardTypes;
    }

    private RechargeLimit[] getRechargelimits() {
        return rechargelimits;
    }

    private void setRechargelimits(RechargeLimit[] rechargelimits) {
        this.rechargelimits = rechargelimits;
    }

    private CostLimit[] getCostLimits() {
        return costLimits;
    }

    private void setCostLimits(CostLimit[] costLimits) {
        this.costLimits = costLimits;
    }

    private PointOfSale[] getPointOfSales() {
        return pointOfSales;
    }

    private void setPointOfSales(PointOfSale[] pointOfSales) {
        this.pointOfSales = pointOfSales;
    }

    private Companies[] getCompanies() {
        return companies;
    }

    private void setCompanies(Companies[] companies) {
        this.companies = companies;
    }

    private Blacklist[] getBlacklists() {
        blacklistList.addAll(Arrays.asList(blacklists));
        return blacklists;
    }

    private void setBlacklists(Blacklist[] blacklists) {
        this.blacklists = blacklists;
    }

    private Movements[] getMovements() {
        return movements;
    }

    private void setMovements(Movements[] movements) {
        this.movements = movements;
    }

    public List<CardTypes> getCardTypesList() {
        cardTypesList.addAll(Arrays.asList(cardTypes));
        return cardTypesList;
    }

    private void setCardTypesList(List<CardTypes> cardTypesList) {
        this.cardTypesList = cardTypesList;
    }

    public List<RechargeLimit> getRechargeLimitList() {
        rechargeLimitList.addAll(Arrays.asList(rechargelimits));
        return rechargeLimitList;
    }

    private void setRechargeLimitList(List<RechargeLimit> rechargeLimitList) {
        this.rechargeLimitList = rechargeLimitList;
    }

    public List<CostLimit> getCostLimitList() {
        costLimitList.addAll(Arrays.asList(costLimits));
        return costLimitList;
    }

    private void setCostLimitList(List<CostLimit> costLimitList) {
        this.costLimitList = costLimitList;
    }

    public List<PointOfSale> getPointOfSaleList() {
        pointOfSaleList.addAll(Arrays.asList(pointOfSales));
        return pointOfSaleList;
    }

    private void setPointOfSaleList(List<PointOfSale> pointOfSaleList) {
        this.pointOfSaleList = pointOfSaleList;
    }

    public List<Companies> getCompaniesList() {
        companiesList.addAll(Arrays.asList(companies));
        return companiesList;
    }

    private void setCompaniesList(List<Companies> companiesList) {
        this.companiesList = companiesList;
    }

    public List<Blacklist> getBlacklistList() {
        blacklistList.addAll(Arrays.asList(blacklists));
        return blacklistList;
    }

    private void setBlacklistList(List<Blacklist> blacklistList) {
        this.blacklistList = blacklistList;
    }

    public List<Movements> getMovementsList() {
        movementsList.addAll(Arrays.asList(movements));
        return movementsList;
    }

    private void setMovementsList(List<Movements> movementsList) {
        this.movementsList = movementsList;
    }

    @Override
    public String toString() {
        return "ConfigurationResponse{" + "cardTypesList=" + cardTypesList.size() + ", rechargeLimitList=" + rechargeLimitList.size() + ", costLimitList=" + costLimitList.size() + ", pointOfSaleList=" + pointOfSaleList.size() + ", companiesList=" + companiesList.size() + ", blacklistList=" + blacklistList.size() + ", movementsList=" + movementsList.size() + '}';
    }
}
