package mx.transport.recharge.nfc;

import android.util.Log;
import android.widget.Toast;

import com.telpo.tps550.api.TelpoException;
import com.telpo.tps550.api.nfc.Nfc;

import mx.cardnfc.model.Card;

public class UtilNfc {

    private static UtilNfc instance = null;
    private byte blockNum_1 = 1;
    private byte blockNum_2 = 2;
    private byte blockNum_3 = 3;
    long time1,time2;
    private Nfc nfc;

    public static UtilNfc getInstance(Nfc nfc) {
        if (instance == null) {
            instance = new UtilNfc();
        }
        return instance;
    }

    public boolean authenticate(Nfc nfc){
        Boolean status = true;
        byte[] passwd={(byte) 0xff,(byte) 0xff,(byte) 0xff,(byte) 0xff,(byte) 0xff,(byte) 0xff};
        try {
            time1=System.currentTimeMillis();
            nfc.m1_authenticate(blockNum_1, (byte)0x0A, passwd);
            time2=System.currentTimeMillis();
            Log.e("yw m1_authenticate",(time2-time1)+"");

        } catch (TelpoException e) {
            status = false;
            e.printStackTrace();
            Log.e("yw",e.toString());
        }
        return status;
    }

    private static String asciiToHex(String asciiStr) {
        char[] chars = asciiStr.toCharArray();
        StringBuilder hex = new StringBuilder();
        for (char ch : chars) {
            hex.append(Integer.toHexString((int) ch));
        }
        return hex.toString();
    }

    private static String hexToAscii(String hexStr) {
        StringBuilder output = new StringBuilder("");
        for (int i = 0; i < hexStr.length(); i += 2) {
            String str = hexStr.substring(i, i + 2);
            output.append((char) Integer.parseInt(str, 16));
        }
        return output.toString();
    }

    public static byte[] toByteArray(String hexString) {
        hexString = fillString(hexString);
        String ascci = hexToAscii(hexString);
        int hexStringLength = ascci.length();
        byte[] byteArray = null;
        int count = 0;
        char c;
        int i;

        // Count number of hex characters
        for (i = 0; i < hexStringLength; i++) {
            c = ascci.charAt(i);
            if (c >= '0' && c <= '9' || c >= 'A' && c <= 'F' || c >= 'a' && c <= 'f') {
                count++;
            }
        }

        byteArray = new byte[(count + 1) / 2];
        boolean first = true;
        int len = 0;
        int value;
        for (i = 0; i < hexStringLength; i++) {
            c = hexString.charAt(i);
            if (c >= '0' && c <= '9') {
                value = c - '0';
            } else if (c >= 'A' && c <= 'F') {
                value = c - 'A' + 10;
            } else if (c >= 'a' && c <= 'f') {
                value = c - 'a' + 10;
            } else {
                value = -1;
            }

            if (value >= 0) {

                if (first) {
                    byteArray[len] = (byte) (value << 4);
                } else {
                    byteArray[len] |= value;
                    len++;
                }
                first = !first;
            }
        }
        return byteArray;
    }


    public static String fillString(String content){
        int size = content.length();
        String c = content;
        if(size < 16){
          int spaces = 16 - size;
          for(int s = 0;  s < spaces; s++){
              c += " ";
          }
        }
        return c;
    }


    public void writeBlockData(Card card) {
        Boolean status = true;

        Log.d("TAG", "writeBlockData...");

        try {
           /// nfc.m1_write_block(blockNum_1, blockData, blockData.length);

            byte[] blockData1 = toByteArray(card.getParam_1());
            byte[] blockData3 = toByteArray(card.getParam_2());
            byte[] blockData2 = toByteArray(card.getParam_3());

            nfc.m1_write_block( blockNum_1,blockData1 , blockData1.length);
            nfc.m1_write_block( blockNum_2, blockData2, blockData2.length);
            nfc.m1_write_block( blockNum_3, blockData3, blockData3.length);

        } catch (TelpoException e) {
            status = false;
            Log.e("yw",e.toString());
            e.printStackTrace();
        }

        if (status) {
            Log.d("TAG", "writeBlockData success!");
                  } else {
            Log.e("TAG", "writeBlockData fail!");
         }
    }

}
