package mx.transport.recharge.ui.buy;

import android.nfc.Tag;

/*import mx.cardnfc.constants.CardConstants;
import mx.cardnfc.model.Card;
import mx.cardnfc.model.CardProperties;
import mx.cardnfc.recharge.callback.WriteCardCallback;
import mx.cardnfc.task.WriteCardTask;*/
import mx.cardnfc.constants.CardConstants;
import mx.cardnfc.model.Card;
import mx.cardnfc.model.CardProperties;
import mx.cardnfc.recharge.callback.WriteCardCallback;
import mx.cardnfc.task.WriteCardTask;
import mx.transport.recharge.R;
import mx.transport.recharge.base.ActivityBase;
import mx.transport.recharge.base.BaseResponse;
import mx.transport.recharge.controller.MainController;
import mx.transport.recharge.listener.HandleListener;
import mx.transport.recharge.model.CardBuy;
import mx.transport.recharge.model.User;
import mx.transport.recharge.model.UserBuy;
import mx.transport.recharge.model.UserInfo;
import mx.transport.recharge.nfc.UtilNfc;
import mx.transport.recharge.preference.RechargePreference;
import mx.transport.recharge.realm.RealmConfiguration;
import mx.transport.recharge.util.RechargeUtil;
import mx.transport.recharge.util.constants.RechargeConstants;

public class BuyPresenter implements HandleListener, BaseResponse {

    private ActivityBase activity;
    private MainController controller;
    private RechargePreference preferences;
    private BuyView view;
    private RechargeUtil util;
    private RealmConfiguration configurationService;
    private UserInfo info;
    private User user;
    private CardBuy cardBuy;
    private String imei;

    private Tag tag;
    private CardProperties cardProperties;

    public BuyPresenter(ActivityBase activity, MainController controller, RechargePreference preferences, RealmConfiguration configurationService, BuyView view) {
        this.activity = activity;
        this.controller = controller;
        this.view = view;
        this.util = RechargeUtil.getInstance(activity);
        this.preferences = preferences;
        this.configurationService = configurationService;
        this.user = preferences.getUser();
        this.info = configurationService.getUser();
        this.imei = preferences.getStringData(RechargeConstants.PF_IMEI);
    }

    public void onCardRegister(Tag tag, CardProperties cardProperties, String price, String netCharge, String type, boolean custom, UserBuy userBuy, UtilNfc utilNfc) {
        this.tag = tag;
        activity.showProgress();
        this.cardProperties = cardProperties;
        cardBuy = buildCard(cardProperties.getCardId(), price, netCharge, type, custom, userBuy);
        System.out.println(cardBuy.toString());

        Card card = new Card(
                CardConstants.KEY_1,
                cardProperties.getCardId(),
                info.getPointCia() + CardConstants.SEPARATOR_SIMPLE + info.getCompanyId(),
                type +  CardConstants.SEPARATOR_SIMPLE + "NFC" +  CardConstants.SEPARATOR_SIMPLE +  info.getCurrency(),
                "0" +  CardConstants.SEPARATOR_SIMPLE + netCharge,
                "",
                "",
                "",
                "",
                "",
                "",
                "",
                util.getSimpleDate());

        utilNfc.writeBlockData(card);
        activity.hiddenProgress();
        view.onSuccessWrite();
        view.onSuccessBuy();
    }


    /*
    public void onCardRegister(Tag tag, CardProperties cardProperties, String price, String netCharge, String type, boolean custom, UserBuy userBuy) {
        this.tag = tag;
        this.cardProperties = cardProperties;
        cardBuy = buildCard(cardProperties.getCardId(), price, netCharge, type, custom, userBuy);
        System.out.println(cardBuy.toString());

        if (util.isConnected()) {
            controller.callBuyCard(cardBuy).subscribe(this::onHandleSuccess, this::onHandleFailed);
            activity.showProgress();
        } else {
            activity.showMessage(activity.getString(R.string.lbl_internet_connection));
        }*/
 /*
        Card card = new Card(
                CardConstants.KEY_1,
                cardProperties.getCardId(),
                info.getPointCia() + CardConstants.SEPARATOR_SIMPLE + info.getCompanyId(),
                type +  CardConstants.SEPARATOR_SIMPLE + "NFC" +  CardConstants.SEPARATOR_SIMPLE +  info.getCurrency(),
                "0" +  CardConstants.SEPARATOR_SIMPLE + netCharge,
                "",
                "",
                "",
                "",
                "",
                "",
                "",
                util.getSimpleDate());

        new WriteCardTask(activity, tag, card, new WriteCardCallback() {
            @Override
            public void onCardWrite() {
                activity.hiddenProgress();
                view.onSuccessWrite();
                view.onSuccessBuy();
            }

            @Override
            public void onCardWriteInvalidCard() {
                activity.hiddenProgress();
            }

            @Override
            public void onCardWriteException(Throwable throwable) {
                throwable.printStackTrace();
                activity.hiddenProgress();

            }
        }).execute();
    }*/

    private CardBuy buildCard(String idCard, String price, String netCharge, String type, boolean custom, UserBuy userBuy) {
        CardBuy cardBuy = new CardBuy(imei, user.getIdUser(), info.getPointCia(), info.getCompanyId(), idCard, price.replace("$", ""), netCharge, info.getCurrency(), custom, Integer.parseInt(type), util.getDate(), userBuy);
        return cardBuy;
    }

    @Override
    public void onHandleSuccess(Object object) {
        try {
            mx.transport.recharge.model.response.BaseResponse baseResponse = (mx.transport.recharge.model.response.BaseResponse) object;
            if (baseResponse != null) {
                util.onResponseValidate(this, object, 99);
            }
        } catch (Exception e) {
            e.printStackTrace();
        }
        activity.hiddenProgress();
    }

    @Override
    public void onHandleFailed(Throwable t) {
        activity.showMessage(t.getMessage());
        activity.hiddenProgress();
    }

    @Override
    public void onSuccess(String json) {

    }

    @Override
    public void onSuccessRequest(int idRequest, Object obj) {
        try {
            mx.transport.recharge.model.response.BaseResponse baseResponse = (mx.transport.recharge.model.response.BaseResponse) obj;
            activity.showMessage(baseResponse.message);
            if (baseResponse.status) {
                view.onSuccessBuy();
            }
        } catch (Exception e) {
            e.printStackTrace();
        }
    }

    @Override
    public void onError(String message) {
        activity.showMessage(message);
    }

}
