package mx.transport.recharge.ui.history;

import mx.transport.recharge.base.ActivityBase;
import mx.transport.recharge.base.BaseResponse;
import mx.transport.recharge.controller.MainController;
import mx.transport.recharge.listener.HandleListener;
import mx.transport.recharge.preference.RechargePreference;
import mx.transport.recharge.ui.login.LoginView;
import mx.transport.recharge.util.PermissionUtils;
import mx.transport.recharge.util.RechargeUtil;

public class HistoryPresenter implements HandleListener, BaseResponse {

    private ActivityBase activity;
    private MainController controller;
    private RechargePreference preferences;
    private LoginView view;
    private RechargeUtil util;
    private PermissionUtils permissionUtils;

    public HistoryPresenter(ActivityBase activity, MainController controller, RechargePreference preferences, PermissionUtils permissionUtils, LoginView view) {
        this.activity = activity;
        this.controller = controller;
        this.view = view;
        this.util = RechargeUtil.getInstance(activity);
        this.preferences = preferences;
        this.permissionUtils = permissionUtils;
    }

    @Override
    public void onHandleSuccess(Object object) {
        try {
            mx.transport.recharge.model.response.BaseResponse baseResponse = (mx.transport.recharge.model.response.BaseResponse) object;
            if (baseResponse != null) {
                util.onResponseValidate(this, object, 0);
            }
        } catch (Exception e) {
            e.printStackTrace();
        }
        activity.hiddenProgress();
    }

    @Override
    public void onHandleFailed(Throwable t) {
        activity.showMessage(t.getMessage());
        activity.hiddenProgress();
    }

    @Override
    public void onSuccess(String json) {
        try {
            /*UserResponse recharger = new Gson().fromJson(json, UserResponse.class);
            if (recharger != null) {
                preferences.saveUser(recharger.getUser());
                //vista
            }*/
        } catch (Exception e) {
            e.printStackTrace();
        }
    }

    @Override
    public void onSuccessRequest(int idRequest, Object obj) {

    }

    @Override
    public void onError(String message) {
        activity.showMessage(message);
    }


}
