package mx.transport.recharge.ui.recharger;

import android.os.Bundle;
import androidx.annotation.NonNull;
import androidx.annotation.Nullable;
import android.text.Editable;
import android.text.TextUtils;
import android.text.TextWatcher;
import android.view.LayoutInflater;
import android.view.View;
import android.view.ViewGroup;
import android.widget.EditText;
import android.widget.TextView;


import butterknife.BindView;
import butterknife.ButterKnife;
import mx.transport.recharge.R;
import mx.transport.recharge.activities.MainActivity;
import mx.transport.recharge.base.FragmentBase;
import mx.transport.recharge.listener.AmountLister;
import mx.transport.recharge.model.Product;


public class RechargerFragment extends FragmentBase {

    private static final String TAG = RechargerFragment.class.getName();
    private Product product;

    @BindView(R.id.layout_animation)
    View animationLayout;
    @BindView(R.id.layout_consulting)
    View consultingLayout;

    @BindView(R.id.tv_message)
    TextView messageTv;

    @BindView(R.id.ed_uid)
    EditText uidEd;
    @BindView(R.id.ed_company)
    EditText companyEd;
    @BindView(R.id.ed_card_type)
    EditText cardTypeEd;
    @BindView(R.id.ed_balance)
    EditText balanceEd;
    @BindView(R.id.ed_add)
    EditText addEd;
    @BindView(R.id.ed_total)
    EditText totalEd;

    public static RechargerFragment newInstance() {
        return new RechargerFragment();
    }


    @Override
    public View onCreateView(LayoutInflater inflater, ViewGroup container, Bundle savedInstanceState) {
        rootView = inflater.inflate(R.layout.fragment_recharge, container, false);
        unbinder = ButterKnife.bind(this, rootView);
        return rootView;
    }

    @Override
    public void onViewCreated(@NonNull View view, @Nullable Bundle savedInstanceState) {
        super.onViewCreated(view, savedInstanceState);
        messageTv.setText(getString(util.isTelpo() ? R.string.lbl_message_consulting_telpo : R.string.lbl_message_consulting_phone));
        /*boolean isEnabled = ((MainActivity) activity).mAdapter.isEnabled();
        if (isEnabled) {
            ((MainActivity) activity).onSetupForegroundDispatch();
        }*/
        product = realmConfiguration.getProduct();
        addEd.addTextChangedListener(new TextWatcher() {
            @Override
            public void beforeTextChanged(CharSequence charSequence, int i, int i1, int i2) {

            }

            @Override
            public void onTextChanged(CharSequence charSequence, int i, int i1, int i2) {
                int size = charSequence.length();
                System.out.println("SIZE" + size);
                double p = TextUtils.isEmpty(balanceEd.getText().toString().replace("$","")) ? 0d : Double.parseDouble(balanceEd.getText().toString().replace("$",""));
                util.validateAmount(charSequence.toString(), p, product.getTope(), new AmountLister() {

                    @Override
                    public void onAmountUpdate(double amount) {
                        totalEd.setText("$" + amount);
                    }

                    @Override
                    public void onAmountError(String message) {
                        addEd.setText("");
                        totalEd.setText("$" + product.getCosto());
                        activity.showMessageDialog(message);
                    }

                    @Override
                    public void onAmountReset() {
                        totalEd.setText("$" + product.getCosto());
                    }
                });

            }

            @Override
            public void afterTextChanged(Editable editable) {

            }
        });
    }


    @Override
    public void onResume() {
        super.onResume();
        //((MainActivity) activity).onEnableForegroundDispatch();
    }

    @Override
    public void onPause() {
        super.onPause();
        //((MainActivity) activity).onDisableForegroundDispatch();
    }

    /*@Override
    public void onCardRead(Tag tag) {
        activity.showProgress();
        new InformationCardTask(activity, tag, this).execute();
    }

    @Override
    public void onCardReadComplete(CardInformation information) {
        activity.hiddenProgress();
        try {
            CardTypes cardTypes = realmConfiguration.getCardType(information.getCardTypeId());
            Companies companies = realmConfiguration.getCompanies(information.getCompanyId());

            cardTypeEd.setText(cardTypes.getDes());
            companyEd.setText(companies.getDes());
            uidEd.setText(information.getCardId());
            balanceEd.setText("$" + information.getBalance());
            consultingLayout.setVisibility(View.VISIBLE);
            animationLayout.setVisibility(View.GONE);

        } catch (Exception e){
            e.printStackTrace();
        }
    }

    @Override
    public void onCardReadInvalidCard() {
        activity.hiddenProgress();
        activity.showMessageDialog(getString(R.string.lbl_message_card_not_fount));
    }

    @Override
    public void onCardReadNotFound() {
        activity.hiddenProgress();
        activity.showMessage(getString(R.string.lbl_message_card_not_fount));
    }

    @Override
    public void onCardReadException(Throwable throwable) {
        activity.hiddenProgress();
        throwable.printStackTrace();
    }*/

    @Override
    public void onDestroy() {
        super.onDestroy();
        if (unbinder != null) {
            unbinder.unbind();
        }
    }

}
