package mx.cardnfc.task;

import android.app.Activity;
import android.nfc.Tag;
import android.nfc.tech.MifareClassic;
import android.os.AsyncTask;

//import com.google.zxing.client.android.BeepManager;

import mx.cardnfc.constants.CardConstants;
import mx.cardnfc.model.CardInformation;
import mx.cardnfc.model.CardProperties;
import mx.cardnfc.recharge.callback.InformationCallback;
import mx.cardnfc.util.CardUtil;

public class InformationCardTask extends AsyncTask<Void, Void, Void> {

    private final Tag tag;
    private final CardUtil cardUtil;
    private final InformationCallback callback;
    private CardProperties card;
    private CardInformation information;
   // private BeepManager mBeepManager;
    private boolean invalidCard;

    public InformationCardTask(Activity activity, Tag tag, InformationCallback callback) {
        this.tag = tag;
        this.callback = callback;
        this.cardUtil = CardUtil.getInstance();
//        this.mBeepManager = new BeepManager(activity);
    }

    @Override
    protected Void doInBackground(Void... voids) {
        final MifareClassic mfc = MifareClassic.get(tag);
        try {
            if (mfc != null) {
                int t = mfc.getType();
                int s = mfc.getSize();
                boolean isValid = cardUtil.cardValidate(t, s);
                mfc.connect();
                if (isValid) {
                    card = cardUtil.cardInformation(mfc);
                    information = cardUtil.cardReadStorage(mfc);
                    if (card.getCardId().equals(information.getCardId()) && information.getOwner().equals(CardConstants.KEY_1)) {
                        invalidCard = false;
                    } else {
                        information = null;
                        invalidCard = true;
                    }
                } else {
                    invalidCard = true;
                }
            }
        } catch (Exception e) {
            e.printStackTrace();
            information = null;
            invalidCard = true;
        } finally {
            try {
                mfc.close();
            } catch (Exception e) {
                e.printStackTrace();
            }
        }
        return null;
    }

    @Override
    protected void onPostExecute(Void aVoid) {
        super.onPostExecute(aVoid);
       // mBeepManager.playBeepSoundAndVibrate();
        if (information != null) {
            callback.onCardReadComplete(information);
        } else {
            if (invalidCard) {
                //callback.onCardReadInvalidCard();
                callback.onCardReadNotFound();
            }
        }
    }
}
