package mx.cardnfc.task;

import android.app.Activity;
import android.nfc.Tag;
import android.nfc.tech.MifareClassic;
import android.os.AsyncTask;

//import com.google.zxing.client.android.BeepManager;

import mx.cardnfc.constants.CardConstants;
import mx.cardnfc.recharge.callback.ReadCardCallback;
import mx.cardnfc.model.CardProperties;
import mx.cardnfc.util.CardUtil;

public class ReadCardTask extends AsyncTask<Void, Void, Void> {

    private final Tag tag;
    private final CardUtil cardUtil;
    private final ReadCardCallback callback;
    private CardProperties card;
   // private BeepManager mBeepManager;

    public ReadCardTask(Activity activity, Tag tag, ReadCardCallback callback) {
        this.tag = tag;
        this.callback = callback;
        this.cardUtil = CardUtil.getInstance();
   //     this.mBeepManager = new BeepManager(activity);
    }

    @Override
    protected Void doInBackground(Void... voids) {
        final MifareClassic mfc = MifareClassic.get(tag);
        try {
            if (mfc != null) {
                int t = mfc.getType();
                int s = mfc.getSize();
                boolean isValid = cardUtil.cardValidate(t, s);
                mfc.connect();
                if (isValid) {
                    card = cardUtil.cardInformation(mfc);
                    String param = cardUtil.readBlock(mfc, 1);
                    /*if (param.equals(CardConstants.KEY_1)) {
                        callback.onCardReadExist();
                        card = null;
                    }*/
                    card = null;
                     cardUtil.clearBlock(mfc);
                } else {
                    callback.onCardReadInvalidCard();
                    card = null;
                }
            }
        } catch (Exception e) {
            callback.onCardReadException(e);
            card = null;
        } finally {
            try {
                mfc.close();
            } catch (Exception e) {
                e.printStackTrace();
            }
        }
        return null;
    }

    @Override
    protected void onPostExecute(Void aVoid) {
        super.onPostExecute(aVoid);
   //     mBeepManager.playBeepSoundAndVibrate();
        if (card != null) {
            callback.onCardReadComplete(card);
        } else {
            callback.onCardReadNotFound();
        }
    }
}
